package com.huimv.eartag2.manage2.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.manage2.mapper.EartagEartagRegister2Mapper;
import com.huimv.eartag2.manage2.pojo.EartagEartagRegister2;
import com.huimv.eartag2.manage2.service.EartagDeviceRegisterService;
import com.huimv.eartag2.manage2.utils.PdfUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-07-22
 */
@RestController
@RequestMapping("/eartag-device-register")
public class EartagDeviceRegisterController {

    @Resource
    private EartagDeviceRegisterService eartagDeviceRegisterService;
    @Autowired
    private EartagEartagRegister2Mapper register2Mapper;

    /**
     * @description: 【添加】设置栋舍单元
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/setPigpen")
    public Result setDeviceRegister(@RequestBody List<Map<String, String>> maps){
        return eartagDeviceRegisterService.set(maps);
    }


    @PostMapping("/setFarmer")
    public Result setFarmer(@RequestBody List<Map<String, Integer>> maps){
        return eartagDeviceRegisterService.setFarmer(maps);
    }
    /**
     * @description: 【删除】
     * @author: 静静
     * @param: ids
     **/
    @PostMapping("/remove")
    public Result removeDeviceRegister(@RequestBody String ids){
        return eartagDeviceRegisterService.remove(ids);
    }

    /**
     * @description: 【修改】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/update")
    public Result updateDeviceRegister(@RequestBody  Map<String, String> maps){
        return eartagDeviceRegisterService.update(maps);
    }
    /**
     * @description: 【查询】 分页查询
     * @author: 静静
     * @param: paramsMap
     **/
    @PostMapping("/list")
    public Result list(@RequestBody Map<String,String> paramsMap){
        return eartagDeviceRegisterService.list(paramsMap);
    }

    /**
     * @description: 【增加】
     * @author: 静静
     * @param: maps
     **/
    @PostMapping("/add")
    public Result add(@RequestBody Map<String, String> maps){
        return eartagDeviceRegisterService.add(maps);
    }

    /**
     * @description: 【删除】取消栋舍单元设置
     * @author: 静静
     **/
    @PostMapping("/cancel")
    public Result cancelPigpen(@RequestBody String ids){
        return eartagDeviceRegisterService.cancel(ids);
    }

    /**
     * @description: 【查询】根据farmID获取设备编码
     * @author: 静静
     **/
    @GetMapping("/getDeviceCode")
    public Result getDeviceCode(@RequestParam(name = "farmId") String farmCode){
        return eartagDeviceRegisterService.getDeviceCode(farmCode);
    }

    @GetMapping("/printData")
    public void printChi(HttpServletResponse response/*,@RequestParam(name = "eartag") String eartag*/) throws Exception {
        String farmId = "330112002";
        QueryWrapper<EartagEartagRegister2> register2QueryWrapper = new QueryWrapper<>();
        register2QueryWrapper.eq("farm_id", farmId);
        List<EartagEartagRegister2> eartagEartagRegister2s = register2Mapper.selectList(register2QueryWrapper);
        for (EartagEartagRegister2 eartagEartagRegister2 : eartagEartagRegister2s) {
            String earmark = eartagEartagRegister2.getEarmark();
            eartagDeviceRegisterService.getData(earmark);
            String path = "G://"+earmark+".xls";
            PdfUtil.returnPdfStream3(response, path, earmark);
        }
    }
}

